#ifndef EFL_VPATH_FILE_CORE_EO_HH
#define EFL_VPATH_FILE_CORE_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_vpath_file.eo.h"
#include "efl_vpath_file_core.eo.h"
#include "eo_base.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_vpath_file.eo.hh"
#include "eo_base.eo.hh"
namespace efl { namespace vpath { namespace file { 
struct Core;
} } } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::vpath::file::Core> : ::std::true_type {}; } }

namespace eo_cxx {
namespace efl { namespace vpath { namespace file { 
struct Core {
   static Eo_Class const* _eo_class()
   {
      return EFL_VPATH_FILE_CORE_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::efl::vpath::file::Core() const;
   operator ::efl::vpath::file::Core&();
   operator ::efl::vpath::file::Core const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Core,  ::efl::vpath::File,  ::eo::Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Core const ,  ::efl::vpath::File const ,  ::eo::Base const > operator&() const { return {this}; }
   /// @endcond
};
} } } 
}
namespace efl { namespace vpath { namespace file { 
struct Core : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::efl ::vpath::File)
   , EO_CXX_INHERIT( ::eo::Base)
{
   explicit Core( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Core(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Core(Core const& other) = default;
   Core(Core&& other) = default;
   Core& operator=(Core const& other) = default;
   Core& operator=(Core&& other) = default;
   Core()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Core( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Core(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   static Eo_Class const* _eo_class()
   {
      return EFL_VPATH_FILE_CORE_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Core,  ::efl::vpath::File,  ::eo::Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Core const ,  ::efl::vpath::File const ,  ::eo::Base const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Core) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Core>::value, "");
} } } 
#include "efl_vpath_file_core.eo.impl.hh"
#endif
